//                                                                  
// Copyright  2005 Lidor Systems.
// All Rights Reserved.
//
// This file is part of the "LidorSystems.Collector" class Library. 
//                                                                   
// The contents of this file are subject to the LidorSystems.Collector
// License (the "License"), and may not be used except in compliance
// with the License. A copy of the License should have been installed
// in the product's root installation directory. You may also obtain a
// copy of the License at...
//                                                                   
// http://www.lidorsystems.com/products/collector/agreement.html
//                                                             
// Software distributed under this License is distributed on an 
// "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
// implied. See the License for the specific language governing 
// rights and limitations under the License.                        
//   

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using LidorSystems.Collector;
using LidorSystems.Collector.Style;

namespace TabbedMDI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private LidorSystems.Collector.Page pgPanel;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox visualStyle;
		private System.Windows.Forms.CheckBox useTheme;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox colorScheme;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button btnCreateHorizontal;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.RadioButton rbBottom;
		private System.Windows.Forms.RadioButton rbRight;
		private System.Windows.Forms.RadioButton rbTop;
		private System.Windows.Forms.RadioButton rbLeft;
		private System.Windows.Forms.Button btnCreateVertical;
		private LidorSystems.Collector.Group group1;
		private LidorSystems.Collector.Page page1;
		private LidorSystems.Collector.Page page2;
		private LidorSystems.Collector.Page page3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pgPanel = new LidorSystems.Collector.Page();
			this.btnCreateVertical = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.visualStyle = new System.Windows.Forms.ComboBox();
			this.useTheme = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();
			this.colorScheme = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnApply = new System.Windows.Forms.Button();
			this.rbBottom = new System.Windows.Forms.RadioButton();
			this.rbRight = new System.Windows.Forms.RadioButton();
			this.rbTop = new System.Windows.Forms.RadioButton();
			this.rbLeft = new System.Windows.Forms.RadioButton();
			this.btnCreateHorizontal = new System.Windows.Forms.Button();
			this.group1 = new LidorSystems.Collector.Group();
			this.page1 = new LidorSystems.Collector.Page();
			this.page2 = new LidorSystems.Collector.Page();
			this.page3 = new LidorSystems.Collector.Page();
			this.pgPanel.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.group1)).BeginInit();
			this.group1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pgPanel
			// 
			this.pgPanel.Controls.Add(this.btnCreateVertical);
			this.pgPanel.Controls.Add(this.groupBox2);
			this.pgPanel.Controls.Add(this.groupBox1);
			this.pgPanel.Controls.Add(this.btnCreateHorizontal);
			this.pgPanel.Dock = System.Windows.Forms.DockStyle.Right;
			this.pgPanel.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.pgPanel.Location = new System.Drawing.Point(421, 0);
			this.pgPanel.Name = "pgPanel";
			this.pgPanel.Size = new System.Drawing.Size(179, 414);
			this.pgPanel.TabIndex = 1;
			this.pgPanel.TableObject = null;
			this.pgPanel.Text = "page1";
			// 
			// btnCreateVertical
			// 
			this.btnCreateVertical.BackColor = System.Drawing.SystemColors.Control;
			this.btnCreateVertical.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCreateVertical.Location = new System.Drawing.Point(10, 372);
			this.btnCreateVertical.Name = "btnCreateVertical";
			this.btnCreateVertical.Size = new System.Drawing.Size(160, 24);
			this.btnCreateVertical.TabIndex = 2;
			this.btnCreateVertical.Text = "New Vertical Tab Group";
			this.btnCreateVertical.Click += new System.EventHandler(this.btnCreateVertical_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.visualStyle);
			this.groupBox2.Controls.Add(this.useTheme);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Controls.Add(this.colorScheme);
			this.groupBox2.Location = new System.Drawing.Point(8, 170);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(164, 156);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Style";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(12, 26);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(82, 16);
			this.label3.TabIndex = 0;
			this.label3.Text = "Visual style";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// visualStyle
			// 
			this.visualStyle.Items.AddRange(new object[] {
															 "Default",
															 "Classic",
															 "Office2003",
															 "VS2003",
															 "VS2005"});
			this.visualStyle.Location = new System.Drawing.Point(12, 44);
			this.visualStyle.Name = "visualStyle";
			this.visualStyle.Size = new System.Drawing.Size(116, 23);
			this.visualStyle.TabIndex = 1;
			this.visualStyle.Text = "Default";
			this.visualStyle.SelectedIndexChanged += new System.EventHandler(this.visualStyle_SelectedIndexChanged);
			// 
			// useTheme
			// 
			this.useTheme.Location = new System.Drawing.Point(12, 72);
			this.useTheme.Name = "useTheme";
			this.useTheme.Size = new System.Drawing.Size(102, 24);
			this.useTheme.TabIndex = 2;
			this.useTheme.Text = "Use Themes";
			this.useTheme.CheckedChanged += new System.EventHandler(this.useTheme_CheckedChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 102);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(82, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Color scheme";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// colorScheme
			// 
			this.colorScheme.Items.AddRange(new object[] {
															 "Default",
															 "Carrot",
															 "Coral",
															 "DarkForest",
															 "DarkWood",
															 "DeepSea",
															 "Forest",
															 "Gold",
															 "GoldRose",
															 "Lily",
															 "Metalic",
															 "Midnight",
															 "Rose",
															 "Sand",
															 "Sea",
															 "Silver",
															 "Sky",
															 "Strawberry",
															 "Sunset",
															 "Vinegar",
															 "Violet",
															 "Wood"});
			this.colorScheme.Location = new System.Drawing.Point(12, 120);
			this.colorScheme.Name = "colorScheme";
			this.colorScheme.Size = new System.Drawing.Size(116, 23);
			this.colorScheme.TabIndex = 4;
			this.colorScheme.Text = "Default";
			this.colorScheme.SelectedIndexChanged += new System.EventHandler(this.colorScheme_SelectedIndexChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnApply);
			this.groupBox1.Controls.Add(this.rbBottom);
			this.groupBox1.Controls.Add(this.rbRight);
			this.groupBox1.Controls.Add(this.rbTop);
			this.groupBox1.Controls.Add(this.rbLeft);
			this.groupBox1.Location = new System.Drawing.Point(8, 6);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(164, 160);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Tab Orientation";
			// 
			// btnApply
			// 
			this.btnApply.BackColor = System.Drawing.SystemColors.Control;
			this.btnApply.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnApply.Location = new System.Drawing.Point(80, 126);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(72, 24);
			this.btnApply.TabIndex = 4;
			this.btnApply.Text = "Apply";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// rbBottom
			// 
			this.rbBottom.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbBottom.Location = new System.Drawing.Point(12, 94);
			this.rbBottom.Name = "rbBottom";
			this.rbBottom.Size = new System.Drawing.Size(94, 24);
			this.rbBottom.TabIndex = 3;
			this.rbBottom.Text = "Bottom";
			// 
			// rbRight
			// 
			this.rbRight.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbRight.Location = new System.Drawing.Point(12, 70);
			this.rbRight.Name = "rbRight";
			this.rbRight.Size = new System.Drawing.Size(94, 24);
			this.rbRight.TabIndex = 2;
			this.rbRight.Text = "Right";
			// 
			// rbTop
			// 
			this.rbTop.Checked = true;
			this.rbTop.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbTop.Location = new System.Drawing.Point(12, 46);
			this.rbTop.Name = "rbTop";
			this.rbTop.Size = new System.Drawing.Size(94, 24);
			this.rbTop.TabIndex = 1;
			this.rbTop.TabStop = true;
			this.rbTop.Text = "Top";
			// 
			// rbLeft
			// 
			this.rbLeft.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbLeft.Location = new System.Drawing.Point(12, 22);
			this.rbLeft.Name = "rbLeft";
			this.rbLeft.Size = new System.Drawing.Size(94, 24);
			this.rbLeft.TabIndex = 0;
			this.rbLeft.Text = "Left";
			// 
			// btnCreateHorizontal
			// 
			this.btnCreateHorizontal.BackColor = System.Drawing.SystemColors.Control;
			this.btnCreateHorizontal.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCreateHorizontal.Location = new System.Drawing.Point(10, 338);
			this.btnCreateHorizontal.Name = "btnCreateHorizontal";
			this.btnCreateHorizontal.Size = new System.Drawing.Size(160, 24);
			this.btnCreateHorizontal.TabIndex = 0;
			this.btnCreateHorizontal.Text = "New Horizontal Tab Group";
			this.btnCreateHorizontal.Click += new System.EventHandler(this.btnCreateHorizontal_Click);
			// 
			// group1
			// 
			this.group1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.group1.Controls.Add(this.page1);
			this.group1.Controls.Add(this.page2);
			this.group1.Controls.Add(this.page3);
			this.group1.ControlState = LidorSystems.Collector.ControlState.Docked;
			this.group1.Cursor = System.Windows.Forms.Cursors.Default;
			this.group1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.group1.Header = false;
			this.group1.Location = new System.Drawing.Point(0, 0);
			this.group1.Name = "group1";
			this.group1.Pages.AddRange(new LidorSystems.Collector.Page[] {
																			 this.page1,
																			 this.page2,
																			 this.page3});
			this.group1.SelectedPage = this.page1;
			this.group1.Size = new System.Drawing.Size(421, 414);
			this.group1.TabIndex = 2;
			this.group1.Text = "group1";
			// 
			// page1
			// 
			this.page1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page1.Location = new System.Drawing.Point(1, 22);
			this.page1.Name = "page1";
			this.page1.Size = new System.Drawing.Size(419, 391);
			this.page1.StyleFromParent = true;
			this.page1.TabIndex = 0;
			this.page1.TableObject = null;
			this.page1.Text = "page1";
			// 
			// page2
			// 
			this.page2.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page2.Location = new System.Drawing.Point(1, 22);
			this.page2.Name = "page2";
			this.page2.Size = new System.Drawing.Size(419, 391);
			this.page2.StyleFromParent = true;
			this.page2.TabIndex = 1;
			this.page2.TableObject = null;
			this.page2.Text = "page2";
			// 
			// page3
			// 
			this.page3.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page3.Location = new System.Drawing.Point(1, 22);
			this.page3.Name = "page3";
			this.page3.Size = new System.Drawing.Size(419, 391);
			this.page3.StyleFromParent = true;
			this.page3.TabIndex = 2;
			this.page3.TableObject = null;
			this.page3.Text = "page3";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 414);
			this.Controls.Add(this.group1);
			this.Controls.Add(this.pgPanel);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Tabbed MDI";
			this.pgPanel.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.group1)).EndInit();
			this.group1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region Tab Orientation
		private void btnApply_Click(object sender, System.EventArgs e)
		{
			if (rbLeft.Checked)
				ChangeOrientation(TabOrientation.Left);
			else if (rbTop.Checked)
				ChangeOrientation(TabOrientation.Top);
			else if (rbRight.Checked)
				ChangeOrientation(TabOrientation.Right);
			else if (rbBottom.Checked)
				ChangeOrientation(TabOrientation.Bottom);
		}

		private void ChangeOrientation(TabOrientation orientation)
		{
			Group currentGroup = null;
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
				{
					currentGroup = (Group)ctrl;
					if (currentGroup.Style != null)
						currentGroup.Style.Orientation = orientation;
				}
			}
		}
		#endregion

		#region Style
		private VisualStyle GetCurrentVisualStyle()
		{
			VisualStyle vStyle = VisualStyle.Default;
			switch (visualStyle.SelectedItem.ToString())
			{
				case "Classic":
					vStyle = VisualStyle.Classic;
					break;
				case "Office2003":
					vStyle = VisualStyle.Office2003;
					break;
				case "VS2003":
					vStyle = VisualStyle.VS2003;
					break;
				case "VS2005":
					vStyle = VisualStyle.VS2005;
					break;
				default:
					vStyle = VisualStyle.Default;
					break;
			}

			return vStyle;
		}

		private void visualStyle_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			VisualStyle vStyle = GetCurrentVisualStyle();

			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
					((Group)ctrl).VisualStyle = vStyle;
				else if (ctrl is Page)
					((Page)ctrl).VisualStyle = vStyle;
			}
		}

		private void useTheme_CheckedChanged(object sender, System.EventArgs e)
		{
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
					((Group)ctrl).UseTheme = useTheme.Checked;
				else if (ctrl is Page)
					((Page)ctrl).UseTheme = useTheme.Checked;
			}
		}

		private ColorScheme GetCurrentColorScheme()
		{
			ColorScheme scheme = ColorScheme.Default;
			switch (colorScheme.SelectedItem.ToString())
			{
				case "Carrot":
					scheme = ColorScheme.Carrot;
					break;
				case "Coral":
					scheme = ColorScheme.Coral;
					break;
				case "DarkForest":
					scheme = ColorScheme.DarkForest;
					break;
				case "DarkWood":
					scheme = ColorScheme.DarkWood;
					break;
				case "DeepSea":
					scheme = ColorScheme.DeepSea;
					break;
				case "Forest":
					scheme = ColorScheme.Forest;
					break;
				case "Gold":
					scheme = ColorScheme.Gold;
					break;
				case "GoldRose":
					scheme = ColorScheme.GoldRose;
					break;
				case "Lily":
					scheme = ColorScheme.Lily;
					break;
				case "Metalic":
					scheme = ColorScheme.Metalic;
					break;
				case "Midnight":
					scheme = ColorScheme.Midnight;
					break;
				case "Rose":
					scheme = ColorScheme.Rose;
					break;
				case "Sand":
					scheme = ColorScheme.Sand;
					break;
				case "Sea":
					scheme = ColorScheme.Sea;
					break;
				case "Silver":
					scheme = ColorScheme.Silver;
					break;
				case "Strawberry":
					scheme = ColorScheme.Strawberry;
					break;
				case "Sunset":
					scheme = ColorScheme.Sunset;
					break;
				case "Vinegar":
					scheme = ColorScheme.Vinegar;
					break;
				case "Violet":
					scheme = ColorScheme.Violet;
					break;
				case "Wood":
					scheme = ColorScheme.Wood;
					break;
				case "Sky":
				default:
					scheme = ColorScheme.Default;
					break;
			}

			return scheme;
		}

		private void colorScheme_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ColorScheme scheme = GetCurrentColorScheme();
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
				{
					if (((Group)ctrl).Style != null)
						((Group)ctrl).Style.ColorScheme = scheme;
				}
				else if (ctrl is Page)
				{
					if (((Page)ctrl).Style != null)
						((Page)ctrl).Style.ColorScheme = scheme;
				}
			}
		}
		#endregion

		#region New Tab Group
		private void btnCreateHorizontal_Click(object sender, System.EventArgs e)
		{
			CreateNewTabGroup(DockStyle.Bottom);
		}

		private void btnCreateVertical_Click(object sender, System.EventArgs e)
		{
			CreateNewTabGroup(DockStyle.Right);
		}

		private void CreateNewTabGroup(DockStyle dock)
		{
			Group newGroup = new Group();
			newGroup.Text = "Group" + ((int)(this.Controls.Count+1)).ToString();
			newGroup.Header = false;
			newGroup.BorderStyle = BorderStyle.None;
			newGroup.Dock = dock;

			if (newGroup.Style != null)
			{
				if (rbLeft.Checked)
					newGroup.Style.Orientation = TabOrientation.Left;
				else if (rbTop.Checked)
					newGroup.Style.Orientation = TabOrientation.Top;
				else if (rbRight.Checked)
					newGroup.Style.Orientation = TabOrientation.Right;
				else if (rbBottom.Checked)
					newGroup.Style.Orientation = TabOrientation.Bottom;

				newGroup.Style.ColorScheme = GetCurrentColorScheme();
			}
			newGroup.VisualStyle = GetCurrentVisualStyle();
			newGroup.UseTheme = useTheme.Checked;

			Group fillGroup = null;
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group && ctrl.Dock == DockStyle.Fill)
				{
					fillGroup = (Group)ctrl;
					break;
				}
			}

			if (fillGroup != null)
			{
				switch (dock)
				{
					case DockStyle.Right:
						newGroup.Size = new Size(fillGroup.Width/2, fillGroup.Height);
						break;
					case DockStyle.Bottom:
						newGroup.Size = new Size(fillGroup.Width, fillGroup.Height/2);
						break;
				}
			}
			else
				newGroup.Size = new Size(100, 100);

			Page newPage = new Page();
			newPage.Text = "Page1";
			newPage.StyleFromParent = true;
			newGroup.Pages.Add(newPage);

			newGroup.Hide();
			this.Controls.Add(newGroup);
			if (fillGroup != null)
				this.Controls.SetChildIndex(newGroup, this.Controls.IndexOf(fillGroup)+1);
			else if (this.pgPanel != null && !this.pgPanel.IsDisposed)
				this.Controls.SetChildIndex(newGroup, this.Controls.IndexOf(this.pgPanel));

			newGroup.Show();
			newPage.Focus();
		}
		#endregion
	}
}
